package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryShareAdjustDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryShareAdjustDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryShareAdjustDao;
import com.friday.custody.entity.DataDictionaryShareAdjustEntity;
import com.friday.custody.service.basicService.DataDictionaryShareAdjustService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryShareAdjustService")
public class DataDictionaryShareAdjustServiceImpl extends ServiceImpl<DataDictionaryShareAdjustDao, DataDictionaryShareAdjustEntity>
        implements DataDictionaryShareAdjustService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryShareAdjustEntity> page = this.page(
                new Query<DataDictionaryShareAdjustEntity>().getPage(params),
                new QueryWrapper<DataDictionaryShareAdjustEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryShareAdjustDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryShareAdjustEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryShareAdjustDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryShareAdjustDetailsEntity::getOriginValue, DataDictionaryShareAdjustDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryShareAdjustEntity::getId, DataDictionaryShareAdjustEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryShareAdjustDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryShareAdjustEntity 查询失败！");
        }
        return result;
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryShareAdjustEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryShareAdjustEntity::getKeyStr
                            ,DataDictionaryShareAdjustEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }

}